'use strict';

exports.__esModule = true;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _descriptors = require('./helpers/descriptors');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var kValue = Symbol('value');
var kPrototype = Symbol('prototype');
var kDescriptors = Symbol('descriptors');
var kCachedGetters = Symbol('cachedGetters');

var LocalSnapshot = function () {
  /**
   * Create a snapshot from the given value.
   *
   * @param {*} value The given value
   */
  function LocalSnapshot(value) {
    _classCallCheck(this, LocalSnapshot);

    /**
     * @type {*}
     * @private
     */
    this[kValue] = value;

    if (value instanceof Object) {
      /**
       * @type {object}
       * @private
       */
      this[kCachedGetters] = (0, _descriptors.cacheGetters)(value);

      /**
       * @type {Object}
       * @private
       */
      this[kPrototype] = Object.getPrototypeOf(value);

      /**
       * @type {object}
       * @private
       */
      this[kDescriptors] = (0, _descriptors.getOwnPropertyDescriptors)(value);
    }
  }

  /**
   * Get the original value.
   *
   * @type {*}
   */


  /**
   * Update the local reference of this value with a new version of this snapshot value.
   *
   * @param {LocalReference} localReference The local reference of this snapshot value
   * @return {void}
   */
  LocalSnapshot.prototype.update = function update(localReference) {
    if (this[kDescriptors] === undefined) return;

    var value = this[kValue];

    var cachedGetters = (0, _descriptors.cacheGetters)(value);
    var prototype = Object.getPrototypeOf(value);
    var descriptors = (0, _descriptors.getOwnPropertyDescriptors)(value);

    // Update snapshot immediately before any other actions
    var oldPrototype = this[kPrototype];
    this[kPrototype] = prototype;
    var oldDescriptors = this[kDescriptors];
    this[kDescriptors] = descriptors;
    var oldCachedGetters = this[kCachedGetters];
    this[kCachedGetters] = cachedGetters;

    // Update prototype
    if (oldPrototype !== prototype) {
      localReference.setPrototypeOf(prototype);
    }

    // Remove deleted properties
    Object.keys(oldDescriptors).forEach(function (property) {
      var newDesc = descriptors[property];
      if (newDesc !== undefined) return;

      localReference.deleteProperty(property);

      if (cachedGetters !== undefined) {
        // There is no need to delete cache for deleted property.
        // Skip localReference#deletePropertyCache() later on.
        delete oldCachedGetters[property];
      }
    });

    // Add or update existed properties
    Object.keys(descriptors).forEach(function (property) {
      var newDesc = descriptors[property];
      var oldDesc = oldDescriptors[property];

      if (!(0, _descriptors.equalDescriptors)(newDesc, oldDesc)) {
        localReference.defineProperty(property, newDesc);
      }
    });

    // Remove deleted getters cache
    Object.keys(oldCachedGetters).forEach(function (property) {
      if (property in cachedGetters) return;

      localReference.deletePropertyCache(property);
    });

    // Set new cached getters
    Object.keys(cachedGetters).forEach(function (property) {
      var newValue = cachedGetters[property];
      var oldValue = oldCachedGetters[property];

      if (!(0, _descriptors.equalValue)(newValue, oldValue)) {
        localReference.setPropertyCache(property, newValue);
      }
    });
  };

  _createClass(LocalSnapshot, [{
    key: 'value',
    get: function get() {
      return this[kValue];
    }

    /**
     * Get the value prototype snapshot.
     *
     * @type {object|undefined}
     */

  }, {
    key: 'prototype',
    get: function get() {
      return this[kPrototype];
    }

    /**
     * Get the value properties descriptors snapshot.
     *
     * @type {object|undefined}
     */

  }, {
    key: 'ownPropertyDescriptors',
    get: function get() {
      return this[kDescriptors];
    }

    /**
     * Get the value properties descriptors snapshot.
     *
     * @type {object|undefined}
     */

  }, {
    key: 'cachedGetters',
    get: function get() {
      return this[kCachedGetters];
    }
  }]);

  return LocalSnapshot;
}();

exports.default = LocalSnapshot;