'use strict';

exports.__esModule = true;

var _ReflectAction2 = require('./ReflectAction');

var _ReflectAction3 = _interopRequireDefault(_ReflectAction2);

var _ReferenceAction = require('./ReferenceAction');

var _ReferenceAction2 = _interopRequireDefault(_ReferenceAction);

var _ReflectApplyAction = require('./ReflectApplyAction');

var _ReflectApplyAction2 = _interopRequireDefault(_ReflectApplyAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ReflectPromiseAction = function (_ReflectAction) {
  _inherits(ReflectPromiseAction, _ReflectAction);

  ReflectPromiseAction.fromValue = function fromValue(session, target, resolve, reject) {
    return new this(target, session.assign(resolve), session.assign(reject));
  };

  function ReflectPromiseAction(target, resolve, reject) {
    _classCallCheck(this, ReflectPromiseAction);

    if (!(resolve instanceof _ReferenceAction2.default)) {
      throw new TypeError('Expect "resolve" to be reference to function: ' + resolve);
    }
    if (!(reject instanceof _ReferenceAction2.default)) {
      throw new TypeError('Expect "reject" to be reference to function: ' + reject);
    }

    var _this = _possibleConstructorReturn(this, _ReflectAction.call(this, target));

    _this.resolve = resolve;
    _this.reject = reject;
    return _this;
  }

  ReflectPromiseAction.prototype.fetch = function fetch(session) {
    var _this2 = this;

    var target = this.fetchTarget(session);

    Promise.resolve(target).then(function (value) {
      session.send(_ReflectApplyAction2.default.fromProxy(session, _this2.resolve, null, [value]));
    }, function (error) {
      session.send(_ReflectApplyAction2.default.fromProxy(session, _this2.reject, null, [error]));
    }).catch(function (err) {
      // We want to throw an error if no-one catch the `error` event on the session.
      // Therefore, we need to use a new stack without promise that the error could be thrown
      // to the process.
      process.nextTick(function () {
        return session.destroy(err);
      });
    });
  };

  ReflectPromiseAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  ReflectPromiseAction.prototype.toArgumentsList = function toArgumentsList() {
    return [this.target, this.resolve, this.reject];
  };

  ReflectPromiseAction.prototype.release = function release(session) {
    this.resolve.release(session);
    this.resolve = null;

    this.reject.release(session);
    this.reject = null;
  };

  return ReflectPromiseAction;
}(_ReflectAction3.default);

exports.default = ReflectPromiseAction;