'use strict';

exports.__esModule = true;

var _ReferencePropertyAction = require('./ReferencePropertyAction');

var _ReferencePropertyAction2 = _interopRequireDefault(_ReferencePropertyAction);

var _descriptors = require('../helpers/descriptors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2017 Moshe Simantov
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Licensed under the Apache License, Version 2.0 (the "License");
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * you may not use this file except in compliance with the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * You may obtain a copy of the License at
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *     http://www.apache.org/licenses/LICENSE-2.0
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Unless required by applicable law or agreed to in writing, software
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * distributed under the License is distributed on an "AS IS" BASIS,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * See the License for the specific language governing permissions and
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * limitations under the License.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var RemoteSetPropertyCacheAction = function (_ReferencePropertyAct) {
  _inherits(RemoteSetPropertyCacheAction, _ReferencePropertyAct);

  function RemoteSetPropertyCacheAction() {
    _classCallCheck(this, RemoteSetPropertyCacheAction);

    return _possibleConstructorReturn(this, _ReferencePropertyAct.apply(this, arguments));
  }

  RemoteSetPropertyCacheAction.prototype.fetch = function fetch(session) {
    var target = session.remote.getTarget(this.reference).target;
    var property = session.fetch(this.property);

    (0, _descriptors.deleteCachedGetter)(target, property);
  };

  RemoteSetPropertyCacheAction.prototype.exec = function exec(session) {
    this.fetch(session);
  };

  return RemoteSetPropertyCacheAction;
}(_ReferencePropertyAction2.default);

exports.default = RemoteSetPropertyCacheAction;